#include <iostream>
#include <vector>

#define endl '\n'
#define int int64_t

using namespace std;

const int64_t BASE = 31;

const int64_t LIMIT = 10000;

int64_t fastPow(int64_t base, int64_t counter, int64_t mod) {
    if (counter == 0ll) {
        return 1ll % mod;
    }

    if (counter == 1ll) {
        return base % mod;
    }

    if (counter % 2ll == 1ll) {
        return (base * fastPow(base, counter - 1, mod)) % mod;
    }

    int64_t current = fastPow(base, counter / 2, mod);

    return (current * current) % mod;
}

signed main() {
    int64_t a, b, k, p;
    cin >> a >> b >> k >> p;

    for (int i = 0; i < p; ++i) {
        int64_t firstDigit = (a * fastPow(10ll, k + i - 1, b)) % b;
        firstDigit = firstDigit * 10ll / b;

        cout << firstDigit;
    }

    cout << endl;

    return 0;
}
