#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll,ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<vvb> vvvb;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e9 + 7;

struct BigInt
{
    vb digs;
    BigInt(int num)
    {
        while (num > 0)
        {
            digs.pb(num % 2);
            num /= 2;
        }
    }
    BigInt()
    {
        digs = vb();
    }
    BigInt(const BigInt &other)
    {
        digs.resize(other.digs.size());
        copy(all(other.digs),digs.begin());
    }
    BigInt(vb diggs)
    {
        digs = diggs;
        while (!digs.empty() && !digs.back()) digs.pop_back();
    }
    bool at(int i)
    {
        if (i < digs.size()) return digs[i];
        return 0;
    }
    BigInt operator+(BigInt other)
    {
        bool remain = false;
        BigInt res;
        for (ll i = 0; i < max(digs.size(),other.digs.size()); i++)
        {
            bool a = at(i), b = other.at(i);
            res.digs.pb(a ^ b ^ remain);
            remain = (remain && (a || b)) || (a && b);
        }
        if (remain) res.digs.pb(remain);
        return res;
    }
    void operator+=(BigInt other)
    {
        *this = *this + other;
    }
    BigInt operator*(BigInt other)
    {
        BigInt c = BigInt(*this);
        BigInt res = 0;
        for (bool x : other.digs)
        {
            if (x) res += c;
            c += c;
        }
        return res;
    }
    void operator*=(BigInt other)
    {
        *this = *this * other;
    }
    BigInt operator-(BigInt other)
    {
        BigInt cpy(*this);
        while (other.digs.size() < digs.size()) other.digs.pb(false);
        for (ll i = 0 ;i<  other.digs.size(); i++) other.digs[i] = !other.digs[i];
        other += 1;
        if (other.digs.size() > digs.size()) other.digs.pop_back();
        cpy += other;
        while (cpy.digs.size() > digs.size()) cpy.digs.pop_back();
        while (!cpy.digs.empty() && !cpy.digs.back()) cpy.digs.pop_back();
        return cpy;
    }
    void operator-=(BigInt other)
    {
        *this = *this - other;
    }
    bool operator<(BigInt other)
    {
        BigInt c1(*this);
        while (other.digs.size() < c1.digs.size()) other.digs.pb(false);
        while (c1.digs.size() < other.digs.size()) c1.digs.pb(false);
        reverse(all(c1.digs)); reverse(all(other.digs));
        return (c1.digs < other.digs);
    }
    bool operator==(BigInt other)
    {
        return digs == other.digs;
    }
    bool operator<=(BigInt other)
    {
        return *this < other || *this == other;
    }
    pair<BigInt,BigInt> divide(BigInt &other)
    {
        BigInt cpy(*this);
        vector<BigInt> p2;
        BigInt cur = BigInt(other);
        while (cur <= *this)
        {
            p2.pb(BigInt(cur));
            cur += cur;
        }
        reverse(all(p2));
        vb res(p2.size());
        ll i = p2.size() - 1;
        for (auto x : p2)
        {
            if (x <= cpy)
            {
                cpy -= x;
                res[i] = true;
            }
            i--;
        }
        return {BigInt(res), cpy};
    }
    BigInt operator/(BigInt other)
    {
        return divide(other).f;
    }
    BigInt operator%(BigInt other)
    {
        return divide(other).s;
    }
    void operator/=(BigInt other)
    {
        *this = *this / other;
    }
    void operator%=(BigInt other)
    {
        *this = *this % other;
    }
    int toInt()
    {
        int res = 0;
        int mul = 1;
        for (auto x : digs)
        {
            res += x * mul;
            mul <<= 1;
        }
        return res;
    }
};

BigInt pow(int a, int b)
{
    if (b == 0) return 1;
    BigInt res = pow(a, b / 2);
    res *= res;
    if (b % 2 == 1) res *= a;
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    int a, b, k, p;
    cin >> a >> b >> k >> p;
    ll cpy = b;
    while (cpy % 5 == 0) cpy /= 5;
    while (cpy % 2 == 0) cpy /= 2;
    BigInt aBig = BigInt(a), bBig = BigInt(b);
    if (cpy == 1)
    {
        //finite representation
        ll chunk = 5;
        ll i = 0;
        while (true)
        {
            BigInt s1 = aBig * pow(10, i + chunk);
            BigInt s2 = s1 / bBig;
            BigInt otherDigits = s2 % pow(10, chunk);
            if (otherDigits == 0) break;
            else i++;
        }
        BigInt seq = (aBig * pow(10, i)) / bBig;
        string digsStr = "";
        while (seq.digs.size() > 0)
        {
            digsStr += '0' + (seq % 10).toInt();
            seq /= 10;
        }
        reverse(all(digsStr));
        string res = "";
        for (ll i=  0; i < p; i++) res += '0';
        for (ll i = 0; (i + k - 1) < digsStr.size(); i++) res[i] = digsStr[i + k - 1];
        cout << res << "\n";
        return 0;
    }
    ll cycle = -1;
    ll i = 1;
    BigInt seq;
    while (true)
    {
        BigInt digits = aBig * pow(10, i) / bBig;
        BigInt otherDigits = (aBig * pow(10, 2 * i) / bBig) % pow(10, i);
        if (digits == otherDigits)
        {
            cycle = i; seq = digits; break;
        }
        else i++;
    }
    string digsStr = "";
    while (seq.digs.size() > 0)
    {
        digsStr += '0' + (seq % 10).toInt();
        seq /= 10;
    }
    reverse(all(digsStr));
    ll start = (k - 1 + cycle) % cycle;
    for (ll i=  0; i < p; i++)
    {
        cout << digsStr[start]; 
        start = (start + 1) % cycle;
    }
    cout << "\n";
    return 0;
}