#include <iostream>
#include <iomanip>
#include <vector>

using namespace std;

long long a, b, k, p;
vector<int> decHead, decCycle;

struct DecimalCalculator
{
    long long a, b;
    long long x, d;
    int poz, val;
    void reset()
    {
        x = a;
        d = b;
        poz = val = 0;
    }
    DecimalCalculator(long long a, long long b)
    {
        this->a = a;
        this->b = b;
        reset();
    }
    void goForward(int step = 1)
    {
        while (step--) {
            poz++;
            x *= 10;
            val = x/d;
            x %= d;
        }
    }
};

void tortoiseAndHare(long long a, long long b)
{
    decHead.clear();
    decCycle.clear();
    DecimalCalculator tortoise(a, b), hare(a, b);
    /// step 1: hare has double the speed of the tortoise
    tortoise.goForward(1);
    hare.goForward(2);
    while (tortoise.x != hare.x) {
        tortoise.goForward(1);
        hare.goForward(2);
    }
    /// step 2: tortoise reset, both have speed of 1; where they meet is the start of the cycle
    tortoise.reset();
    while (tortoise.x != hare.x) {
        tortoise.goForward(1);
        hare.goForward(1);
        decHead.push_back(tortoise.val);
    }
    /// step 3: tortoise has speed of 0, hare has speed of 1; number of steps is length of cycle
    hare.goForward(1);
    decCycle.push_back(hare.val);
    while (tortoise.x != hare.x) {
        hare.goForward(1);
        decCycle.push_back(hare.val);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> a >> b >> k >> p;
    tortoiseAndHare(a, b);
    while (p--) {
        if (k <= decHead.size()) {
            cout << decHead[k-1];
        }
        else {
            cout << decCycle[(k-1 - decHead.size()) % decCycle.size()];
        }
        k++;
    }
    return 0;
}
