#include <iostream>
#include <iomanip>
#include <vector>

using namespace std;

long long a, b, k, p;
int decHeadLen, decCycleLen;

struct DecimalCalculator
{
    long long a, b;
    long long x, d;
    int poz, val;
    void reset()
    {
        x = a;
        d = b;
        poz = val = 0;
    }
    DecimalCalculator(long long a, long long b)
    {
        this->a = a;
        this->b = b;
        reset();
    }
    void goForward(int step = 1)
    {
        while (step--) {
            poz++;
            x *= 10;
            val = x/d;
            x %= d;
        }
    }
    void goToPoz(int poz, int headLen, int cycleLen)
    {
        reset();
        if (poz <= headLen) {
            goForward(poz);
            return;
        }
        goForward(headLen);
        goForward((poz - headLen) % cycleLen);
    }
};

void tortoiseAndHare(long long a, long long b)
{
    DecimalCalculator tortoise(a, b), hare(a, b);
    /// step 1: hare has double the speed of the tortoise
    tortoise.goForward(1);
    hare.goForward(2);
    while (tortoise.x != hare.x) {
        tortoise.goForward(1);
        hare.goForward(2);
    }
    /// step 2: tortoise reset, both have speed of 1; where they meet is the start of the cycle
    tortoise.reset();
    while (tortoise.x != hare.x) {
        tortoise.goForward(1);
        hare.goForward(1);
    }
    decHeadLen = tortoise.poz;
    /// step 3: tortoise has speed of 0, hare has speed of 1; number of steps is length of cycle
    int prevHarePoz = hare.poz;
    hare.goForward(1);
    while (tortoise.x != hare.x) {
        hare.goForward(1);
    }
    decCycleLen = hare.poz - prevHarePoz;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> a >> b >> k >> p;
    tortoiseAndHare(a, b);
    //cout << decHeadLen << ' ' << decCycleLen << '\n';
    DecimalCalculator calc(a, b);
    calc.goToPoz(k, decHeadLen, decCycleLen);
    while (p--) {
        cout << calc.val;
        calc.goForward(1);
    }
    return 0;
}
