// Ignut

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll LEN = 3e6;

int vInd = 0;
int v[LEN];

// ==================================================================== //

const ll MOD = 1e9 + 9;
const int P = 31;

int ppow[LEN + 1];

int add(int a, int b) {
    return a + b >= MOD ? a + b - MOD : a + b;
}

int sub(int a, int b) {
    return a - b >= 0 ? a - b : a - b + MOD;
}

int mult(int a, int b) {
    return 1ll * a * b % MOD;
}

int binpow(int n, int k) {
    int res = 1;
    while (k) {
        if (k & 1) res = mult(res, n);
        n = mult(n, n);
        k >>= 1;
    }
    return res;
}

int divide(int a, int b) {
    return mult(a, binpow(b, MOD - 2));
}

// ================================================================//

void Compute() {
    ppow[0] = 1;
    for (int i = 1; i <= LEN; i ++)
        ppow[i] = mult(ppow[i - 1], P);
}

int hsh[LEN + 1];

void ComputeHash() {
    hsh[0] = 0;
    for (int i = 1; i <= LEN; i ++)
        hsh[i] = add(hsh[i - 1], mult(ppow[i], v[i - 1]));
}

int GetHash(int l, int r) {
    int h = sub(hsh[r + 1], hsh[l]);
    h = divide(h, ppow[l]);
    return h;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0), cout.tie(0);

    // #ifndef ONLINE_JUDGE
    //     freopen("input123.txt", "r", stdin);
    //     freopen("output123.txt", "w", stdout);
    // #endif

    Compute();

    ll a, b; ll k; ll p;
    cin >> a >> b >> k >> p;

    for (ll i = 0; i < LEN; i ++) {
        if (a == 0) {
            while (i < LEN) {
                v[vInd ++] = 0;
                i ++;
            }
            break;
        }
        a *= 10;
        ll d = 0;
        while ((d + 1) * b <= a) d ++;
        v[vInd ++] = d;
        a -= d * b;
    }
    
    ComputeHash();

    ll start = -1, length = -1;

    for (ll st = 0; st < LEN; st ++) {
        if (start != -1) break;
        for (ll len = LEN - st; len >= 1; len --) {
            int h = GetHash(st, st + len - 1);

            bool ok = true;
            if (st + len * 2 >= LEN) continue;

            int cnt = 0;
            for (ll st2 = st + len; st2 < LEN; st2 += len) {
                cnt ++;
                if (cnt == 10) break;
                int h2;
                if (st2 + len - 1 >= LEN) {
                    int l = st2;
                    int r = LEN - 1;
                    int h2 = GetHash(l, r);
                    int h = GetHash(st, st + (r - l + 1) - 1);
                    if (h2 != h) ok = false;
                }
                else {
                    int h2 = GetHash(st2, st2 + len - 1);
                    if (h2 != h) ok = false;
                }

                if (!ok)
                    break;
            }
            if (ok) {
                start = st;
                length = len;
                break;
            }
        }
        if (start != -1) break;
    }

    if (start == -1) {
        start /= 0;
    }

    // cout << start << ' ' << length << '\n';

    // =================================================================== //

    // full base

    while (k + p - 1 <= start) {
        for (int i = k - 1; i < k + p - 1; i ++)
            cout << v[i];
        cout << '\n';
        return 0;
    }

    // base

    while (k <= start) {
        cout << v[k - 1];
        k ++; p --;
    }

    // period

    k --;
    k %= length;
    for (ll i = k; i < k + p; i ++) {
        cout << v[start + (i % length)];
    }

    cout << '\n';
    return 0;
}

/*
*/